function h = eigLpFir(nOrder,passBandEdge,stopBandEdge, alpha)
% eigLpFir : ͭե륿߷ (Type I)
%
%   h = eigLpFir(order,passBandEdge,stopBandEdge,alpha)
%
% 
%   order        : ե륿 ()
%   passBandEdge : ̲ü (ʥȼȿ1.0Ȥ)
%   stopBandEdge : ˻߰ü (ʥȼȿ1.0Ȥ)
%   alpha        : ̲˻߰νŤ(0.0<alpha<1.0)
%
% 
%   h            : ѥ륹
%
%   ե륿 order̲ü passBandEdge
%   ˻߰ü stopBandEdgeŤߥѥ᡼alpha Ϳȡ
%   ͭե륿߷ˡˤ̲ե륿
%   h Ȥƥѥ륹ϡ
%
% $Id: eigLpFir.m,v 1.2 2007/05/07 11:09:47 sho Exp $
%
% Copyright (C) 2006-2007 Shogo MURAMATSU, All rights reserved
%
error(nargchk(4,4,nargin));

if rem(nOrder,2) ~= 0
    error('϶ǤʤФʤޤ');
end;
if (passBandEdge > stopBandEdge)
    error('̲üϡ˻߰ü㤯ʤФʤޤ');
end

% Ωʥե륿ο
nCoefficients = nOrder/2;

% ̲üδѼȿ
omegaPass = passBandEdge * pi;
% ˻߰üδѼȿ
omegaStop = stopBandEdge * pi;

% Q, P
Q = zeros(nCoefficients+1);
P = zeros(nCoefficients+1);
for iRowCoef = 1:nCoefficients+1
    m=iRowCoef-1;
    for iColCoef = 1:nCoefficients+1
        n=iColCoef-1;
        if m==n
            if m==0
                Q(iRowCoef,iColCoef) = 0;
                P(iRowCoef,iColCoef) = 1-omegaStop/pi;
            else
                Q(iRowCoef,iColCoef) = 1/pi * ...
                    (3/2 * omegaPass ...
                        - 2*sin(m*omegaPass)/m ...
                        + sin(2*m*omegaPass)/(4*m) );           
                P(iRowCoef,iColCoef) = 1/(2*pi) * ...
                    ( pi - omegaStop ...
                        - sin(2*m*omegaStop)/(2*m) );
            end
        else
           if m==0 || n==0
               Q(iRowCoef,iColCoef) = 0;    
           else
               Q(iRowCoef,iColCoef) = 1/pi * ...
                    (omegaPass ...
                        - ( sin(m*omegaPass)/m + sin(n*omegaPass)/n) ...
                        + sin( (m+n)*omegaPass ) / (2 * (m+n) )...
                        + sin( (m-n)*omegaPass ) / (2 * (m-n) ) );
           end
           P(iRowCoef,iColCoef) = 1/(2*pi) * ...
                ( ( - sin( (m+n)*omegaStop )/(m+n) ) ...
                    + ( - sin( (m-n)*omegaStop )/(m-n) ) );
        end
    end
end

% Rʼ¡оΤ͹
R = alpha * P + (1-alpha) * Q;
R = inv(R);

% ٥ȥνʽͤ
b = rand(nCoefficients+1,1);
b = b/norm(b);

% Ǿͭͤбͭ٥ȥη׻
previousCoefficients = zeros(size(b));
epsilon = Inf;
while (epsilon > 1e-9)
    b = R * b;
    b = b/norm(b);
    epsilon = norm(b - previousCoefficients);
    previousCoefficients = b;
end

%lambdaMax = R(1,:) * b / b(1);
%R = lambdaMax * eye(size(R))-R;
%epsilon = Inf;
%while (epsilon > 1e-9)
%    b = R * b;
%    b = b/norm(b);
%    epsilon = norm(b - previousCoefficients);
%    previousCoefficients = b;
%end

h = [flipud(b(2:nCoefficients+1)); 2 * b(1) ;b(2:nCoefficients+1)]; 
h = h/sum(h);

% end of eigLpFir
