function h = eigLpFir(nOrder,passBandEdge,stopBandEdge, alpha)
% eigLpFir : ŗLtB^݌v (Type I)
%
%   h = eigLpFir(order,passBandEdge,stopBandEdge,alpha)
%
% 
%   order        : tB^ ()
%   passBandEdge : ʉ߈[ (iCLXgg1.0Ƃ)
%   stopBandEdge : j~[ (iCLXgg1.0Ƃ)
%   alpha        : ʉ߈Ƒj~̏d(0.0<alpha<1.0)
%
% o
%   h            : CpX
%
%   tB^ orderAʉ߈[ passBandEdgeA
%   j~[ stopBandEdgeAd݃p[^alpha ^ƁA
%   ŗLtB^݌v@ɂʉ߃tB^쐬A
%   h ƂăCpXóB
%
% $Id: eigLpFir.m,v 1.2 2007/05/07 11:09:47 sho Exp $
%
% Copyright (C) 2006-2007 Shogo MURAMATSU, All rights reserved
%
error(nargchk(4,4,nargin));

if rem(nOrder,2) ~= 0
    error('͋łȂ΂Ȃ܂B');
end;
if (passBandEdge > stopBandEdge)
    error('ʉ߈[́Aj~[ႭȂ΂Ȃ܂B');
end

% ƗȃtB^W̐
nCoefficients = nOrder/2;

% ʉ߈[̊ZiKpgj
omegaPass = passBandEdge * pi;
% j~[̊ZiKpgj
omegaStop = stopBandEdge * pi;

% sQ, P̐
Q = zeros(nCoefficients+1);
P = zeros(nCoefficients+1);
for iRowCoef = 1:nCoefficients+1
    m=iRowCoef-1;
    for iColCoef = 1:nCoefficients+1
        n=iColCoef-1;
        if m==n
            if m==0
                Q(iRowCoef,iColCoef) = 0;
                P(iRowCoef,iColCoef) = 1-omegaStop/pi;
            else
                Q(iRowCoef,iColCoef) = 1/pi * ...
                    (3/2 * omegaPass ...
                        - 2*sin(m*omegaPass)/m ...
                        + sin(2*m*omegaPass)/(4*m) );           
                P(iRowCoef,iColCoef) = 1/(2*pi) * ...
                    ( pi - omegaStop ...
                        - sin(2*m*omegaStop)/(2*m) );
            end
        else
           if m==0 || n==0
               Q(iRowCoef,iColCoef) = 0;    
           else
               Q(iRowCoef,iColCoef) = 1/pi * ...
                    (omegaPass ...
                        - ( sin(m*omegaPass)/m + sin(n*omegaPass)/n) ...
                        + sin( (m+n)*omegaPass ) / (2 * (m+n) )...
                        + sin( (m-n)*omegaPass ) / (2 * (m-n) ) );
           end
           P(iRowCoef,iColCoef) = 1/(2*pi) * ...
                ( ( - sin( (m+n)*omegaStop )/(m+n) ) ...
                    + ( - sin( (m-n)*omegaStop )/(m-n) ) );
        end
    end
end

% sR̐iAΏ̂̐lsj
R = alpha * P + (1-alpha) * Q;
R = inv(R);

% WxNg̏il_ɐݒj
b = rand(nCoefficients+1,1);
b = b/norm(b);

% ŏŗLlɑΉŗLxNǧvZ
previousCoefficients = zeros(size(b));
epsilon = Inf;
while (epsilon > 1e-9)
    b = R * b;
    b = b/norm(b);
    epsilon = norm(b - previousCoefficients);
    previousCoefficients = b;
end

%lambdaMax = R(1,:) * b / b(1);
%R = lambdaMax * eye(size(R))-R;
%epsilon = Inf;
%while (epsilon > 1e-9)
%    b = R * b;
%    b = b/norm(b);
%    epsilon = norm(b - previousCoefficients);
%    previousCoefficients = b;
%end

h = [flipud(b(2:nCoefficients+1)); 2 * b(1) ;b(2:nCoefficients+1)]; 
h = h/sum(h);

% end of eigLpFir
