function y = wadcti(x,N);
% WADCTI   :	Wang ι® DCT- I       (ľ)
%
%	Y = WADCTI(X [,N])
%
%	X  : ϥ٥ȥ롤Ϲ 
%	N  : Ѵ
%	
%	Y  : X  DCT-I 
%
%	X ΤȤ٥ȥФѴ
%	N Ϳ줿硤礦褦ˡ
%	X Фղá뤤ڼΤƤԤʤ
%
%	See also: WADCTII, WADCTIII, WADCTIV
%
%	Ref.:	Z. Wang, "Fast Algorithms for the Discrete W 
%		Transform and for the Discrete Fourier Transform,"
%		IEEE Trans. ASSP, Vol.32, No.4,	pp.803-816, Aug. 1984. 
%
% $Id: wadcti.m,v 1.1 2006/04/19 17:34:37 sho Exp $
%
% Copyright (C) 1996-2006 Shogo MURAMATSU, All rights reserved
%
error(nargchk(1,2,nargin));	% οΥå

% 

[x,flag] = rowvecck(x);		%  x ԥ٥ȥΤȤž֡
if nargin == 1	
	N = size(x,1);		% x ιԿѴ M Ȥ롥
else
	x = adjcsize(x,N);	% x Υ M ˹碌롥 
end;

% Wang  ® DCT-I

M = N-1;
SQRT_H = 7.071067811865475e-01;
SQRT_2 = 1.414213562373095e+00;

if M == 2		% 3  DCT-I
	
	x(2,:) = x(2,:)*SQRT_2;
	y(1,:) = (x(1,:) + x(2,:) + x(3,:))/2;
	y(2,:) = (x(1,:)          - x(3,:))*SQRT_H;
	y(3,:) = (x(1,:) - x(2,:) + x(3,:))/2;

elseif rem(M,2) == 0	% M+1  ® DCT-I (M  2 ܿΤȤ)

	HM = M/2;

	% DCT-I, III ˤѴ
	ye = wadcti([x(1:HM,:)+x(N:-1:HM+2,:);SQRT_2*x(HM+1,:)])*SQRT_H;
	yo = wadctiii(x(1:HM,:)-x(N:-1:HM+2,:))*SQRT_H;

	% ִ
	y = iperm([ye;yo]); 	

else		% M+1  DCT-I ι黻 (M  2 ܿǤϤʤȤ)

	y = dcti(x,N);

end;

% 

if flag				%  x ԥ٥ȥΤȤ
	y = y.';		%  y ⡤ԥ٥ȥȤ롥
end;


