function y = wadctiii(x,M);
% WADCTIII :	Wang ι® DCT-III      (ľ)
%
%	Y = WADCTIII(X [,M])
%
%	X  : ϥ٥ȥ롤Ϲ 
%	M  : Ѵ
%	
%	Y  : X  DCT-III 
%
%	X ΤȤ٥ȥФѴ
%	M Ϳ줿硤礦褦ˡ
%	X Фղá뤤ڼΤƤԤʤ
%
%	See also: WADCTI, WADCTII, WADCTIV
%
%	Ref.:	Z. Wang, "Fast Algorithms for the Discrete W 
%		Transform and for the Discrete Fourier Transform,"
%		IEEE Trans. ASSP, Vol.32, No.4,	pp.803-816, Aug. 1984. 
%
% $Id: wadctiii.m,v 1.1 2006/04/19 17:34:37 sho Exp $
%
% Copyright (C) 1996-2006 Shogo MURAMATSU, All rights reserved
%
error(nargchk(1,2,nargin));	% οΥå

% 

[x,flag] = rowvecck(x);		%  x ԥ٥ȥΤȤž֡
if nargin == 1	
	M = size(x,1);		% x ιԿѴ M Ȥ롥
else
	x = adjcsize(x,M);	% x Υ M ˹碌롥 
end;

% Wang  ® DCT-III

SQRT_H = 7.071067811865475e-01;

if M == 2		% 2  DCT-III

	y(1,:) = ( x(1,:) + x(2,:) )*SQRT_H;
	y(2,:) = ( x(1,:) - x(2,:) )*SQRT_H;

elseif rem(M,2) == 0	% M  ® DCT-iII (M  2 ܿΤȤ)

	HM = M/2;

	% ִ
	u = perm(x);

	% DCT-III, IV ˤѴ
	ye = wadctiii(u(1:HM,:));
	yo =  wadctiv(u(HM+1:M,:));
	y(1:HM,:)   =       ( ye + yo )*SQRT_H;
	y(HM+1:M,:) = flipud( ye - yo )*SQRT_H;

else			% M  DCT-III ι黻 (M  2 ܿǤϤʤȤ)

	y = dctiii(x,M);

end;

% 

if flag				%  x ԥ٥ȥΤȤ
	y = y.';		%  y ⡤ԥ٥ȥȤ롥
end;

