function y = wadctiv(x,M)
% WADCTIV  :	Wang ι® DCT-IV       (ľ)
%
%	Y = WADCTIV(X [,M])
%
%	X  : ϥ٥ȥ롤Ϲ 
%	M  : Ѵ
%	
%	Y  : X  DCT-IV 
%
%	X ΤȤ٥ȥФѴ
%	M Ϳ줿硤礦褦ˡ
%	X Фղá뤤ڼΤƤԤʤ
%
%	See also: WADCTI, WADCTII, WADCTIII
%
%	Ref.:	Z. Wang, "On Computing the Discrete Fourier and 
%		Cosine Transforms," IEEE Trans. ASSP, Vol.33, No.4,
%		pp.1341-1344, Oct. 1985. 
%
% $Id: wadctiv.m,v 1.1 2006/04/19 17:34:37 sho Exp $
%
% Copyright (C) 1996-2006 Shogo MURAMATSU, All rights reserved
%
error(nargchk(1,2,nargin));	% οΥå

% 

[x,flag] = rowvecck(x);		%  x ԥ٥ȥΤȤž֡
if nargin == 1	
	M = size(x,1);		% x ιԿѴ M Ȥ롥
else
	x = adjcsize(x,M);	% x Υ M ˹碌롥 
end;

% Wang  ® DCT-IV

SQRT_H = 7.071067811865475e-01;

if M == 2		% 2  DCT-IV

	COSPI_8 = cos(pi/8);
	SINPI_8 = sin(pi/8);
	y(1,:) = x(1,:)*COSPI_8 + x(2,:)*SINPI_8;
	y(2,:) = x(1,:)*SINPI_8 - x(2,:)*COSPI_8;

elseif rem(M,2) == 0	% M  ® DCT-IV (M  2 ܿΤȤ)

	HM = M/2;
	DiagCos = diag( cos(pi*(1:2:M-1)/(4*M)) );
	DiagSin = diag( sin(pi*(1:2:M-1)/(4*M)) );

	% Хե饤ִ 
	ze(1,:) = x(1,:);
	zo(1,:) = x(M,:);
	for i=2:HM
		ze(i,     :) = ( x(2*(i-1),:) + x(2*(i-1)+1,:) )*SQRT_H;
		zo(HM+2-i,:) = ( x(2*(i-1),:) - x(2*(i-1)+1,:) )*SQRT_H;
	end;

	%  DCT-III ˤѴ
	ue = wadctiii(ze);
	uo = diag( (-1).^(0:HM-1) )*wadctiii(zo);

	% ʿ̲ž (ص塤3/3 르ꥺϻѤʤ)
	y(1:HM,  :) =         DiagCos*ue + DiagSin*uo;
	y(HM+1:M,:) = flipud( DiagSin*ue - DiagCos*uo );

else		% M  DCT-IV ι黻 (M  2 ܿǤϤʤȤ)

	y = dctiv(x,M);

end;

% 

if flag				%  x ԥ٥ȥΤȤ
	y = y.';		%  y ⡤ԥ٥ȥȤ롥
end;

