function x = gaussian2cq(sizeX, covMtx)
%
% Inputs
%
%   sizeX: size of output array 
%   covMtx: covariance matrix
%
% Output
%
%   x: array generated by Gauss Func. 
%
% $Id: gaussian2cq.m,v 1.1 2006/06/13 10:21:10 sho Exp $
%
% Copyright (C) 2005-2006 Shogo MURAMATSU, All rights reserved
%
sizeHalf = floor(sizeX / 2);

if size(covMtx,1) == 1 && size(covMtx,2) == 1
    covMtx = covMtx * eye(2);
end;
invCovMtx = inv(covMtx);

iRow = 1;
for n1 = -sizeHalf:sizeHalf
    iCol = 1;
    for n0 = -sizeHalf:sizeHalf    
        p = - 0.5 * [ n0 n1 ] * invCovMtx * [ n0 n1 ].';
        x(iRow,iCol) = exp(p);
        iCol = iCol + 1;
    end;
    iRow = iRow + 1;
end;
x = x / sum(sum(x));

% end of gaussian2cq
